#include "cmemorymodel.h"
#include <algorithm>

CMemoryModel::CMemoryModel()
{
}

void CMemoryModel::insert(unsigned int addr, unsigned char val)
{
    if(addr >= data_.size() )
        {
            data_.resize(addr+1);
        }
    data_.insert(data_.begin()+addr,val);
}

void CMemoryModel::insert(unsigned int addr, std::vector<unsigned char> val)
{
    if( (addr+val.size()) > data_.size())
        {
            //data_.resize(addr+val.size());
        }
    data_.insert(data_.begin()+addr,val.begin(),val.end());
}

void CMemoryModel::owerwrite(unsigned int addr, unsigned char val)
{
    if(addr >= data_.size() )
        {
            data_.resize(addr+1);
        }
    data_[addr] = val;
}

void CMemoryModel::owerwrite(unsigned int addr, std::vector<unsigned char> val)
{
    if( (addr+val.size()) > data_.size())
        {
            data_.resize(addr+val.size());
        }
    std::copy(val.begin(),val.end(),data_.begin()+addr);
}

std::vector<CAbstractIntelHexRecord*> CMemoryModel::toRecords(int rec_size)
{
    //std::cout<<"CMemoryModel::toRecords(int rec_size)"<<std::endl;
    std::vector<CAbstractIntelHexRecord*> res;
    unsigned int curr_addr = 0;
    std::vector<unsigned char> rec_data;
    //std::cout<<"memoty size "<<data_.size()<<std::endl;
    while(curr_addr < data_.size() )
        {
            //std::cout<<"current addr "<<curr_addr<<std::endl;
            rec_data = std::vector<unsigned char>();
            if( (curr_addr+rec_size) > data_.size() )
                {
                    rec_data.insert(rec_data.begin(),data_.begin()+curr_addr,data_.end());
                }
            else
                {
                    rec_data.insert(rec_data.begin(),data_.begin()+curr_addr,data_.begin()+rec_size+curr_addr);
                }

            CAbstractIntelHexRecord* rec = CAbstractIntelHexRecord::createRecord(HRT_BINATY);
            if(rec == 0)
                {
                    std::cout<<"bad RECORD allocation"<<std::endl;
                }
            rec->setAddr(curr_addr);
            rec->setData(rec_data);
            res.push_back(rec);

            curr_addr+=rec_size;
        }

    CAbstractIntelHexRecord* end_rec = CAbstractIntelHexRecord::createRecord(HRT_END_FILE);
    res.push_back(end_rec);

    //std::cout<<"CMemoryModel::toRecords(int rec_size)"<<std::endl;
    return res;

}
