#ifndef INTELHEXRECORD_H
#define INTELHEXRECORD_H

#include <vector>
#include <string>

#define MIN_RECORD_STR_LEN 11

enum EIntelHexRecordType
{
    HRT_BINATY             = 0x00,// запись содержит данные двоичного файла.
    HRT_END_FILE           = 0x01,// запись является концом файла.
    HRT_SEGMENT_ADDR       = 0x02,// запись адреса сегмента (подробнее см. ниже).
    HRT_START_SEGMENT_ADDR = 0x03,// Start Segment Address Record.
    HRT_EXT_ADDR           = 0x04,// запись расширенного адреса (подробнее см. ниже).
    HRT_LINE_ADDR          = 0x05,// Start Linear Address Record

    HRT_INVALID_RECORD
};

class CAbstractIntelHexRecord
{
public:
    CAbstractIntelHexRecord():data_(4){}
    virtual ~CAbstractIntelHexRecord(){}

    static CAbstractIntelHexRecord* createRecord(EIntelHexRecordType);
    static CAbstractIntelHexRecord* createRecord(const std::string&);

    EIntelHexRecordType type();
    unsigned int addr();
    unsigned int record_size();
    std::vector<unsigned char> data();
    void setAddr(int);
    void setData(std::vector<unsigned char> &data);
    virtual std::string toString() = 0;
protected:
    void setRawData(std::vector<unsigned char> &data);
    void setType(EIntelHexRecordType);
    std::vector<unsigned char> data_;
};

class CIntelBinRecord : public CAbstractIntelHexRecord
{
public:
    CIntelBinRecord();
    virtual std::string toString();
};

class CIntelEndFileRecord : public CAbstractIntelHexRecord
{
public:
    CIntelEndFileRecord();
    virtual std::string toString();
};

#endif // INTELHEXRECORD_H
